{-# LANGUAGE OverloadedStrings #-}

module Gitea.Preview.Markdown.Math (katexMath, katexMath') where

import Text.Pandoc (Inline(..), MathType(..), Format(..), Pandoc)
import Text.Pandoc.Walk (walk)
import Text.HTML.TagSoup (escapeHTML)

import qualified Data.Text as T

katexMath' :: Pandoc -> Pandoc
katexMath' = walk katexMath

katexMath :: Inline -> Inline
katexMath (Math InlineMath txt) = RawInline (Format "html") $
    "<code class=\"language-math is-loading\">" <>
    T.pack (escapeHTML (T.unpack txt)) <>
    "</code>"
katexMath (Math DisplayMath txt) = RawInline (Format "html") $
    "<pre class=\"code-block is-loading\"><code class=\"chroma language-math display\">" <>
    T.pack (escapeHTML (T.unpack txt)) <>
    "</code></pre>\n"
katexMath x = x
